set linesize 32000
set pagesize 1000
set termout on
set echo on
set trimspool on

spool simpleindex.log

-- example of adding and index to a table that
-- does not have one

-- show db version

select BANNER_FULL from v$version;

-- first create a table with no index

drop table test;

create table test as
select * from dba_tables;

-- add a bunch of extra rows

insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;
insert /*+append*/ into test select * from test;
commit;

-- make up a single row

insert into test (owner, table_name, tablespace_name) values ('TESTOWNER','TESTTABLE','TESTTABLESPACE');

commit;

execute dbms_stats.gather_table_stats(NULL,'TEST');

-- now query a single row in that
-- table

set timing on

select TABLESPACE_NAME 
from test 
where 
owner='TESTOWNER' and
table_name = 'TESTTABLE';

-- run again to cache

/

set timing off

-- show plan

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

-- create index

create index testi on test (owner, table_name);

-- run query again with index


set timing on

select TABLESPACE_NAME 
from test 
where 
owner='TESTOWNER' and
table_name = 'TESTTABLE';

-- run again to cache

/

set timing off

-- show plan

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

spool off
